// LN^foCX̃foCXhCo(cdev)
// W[ԍ͈Ŏw肵AΓIɊt

#define SUCCESS 0
#define NODE_NAME "char_drv"

#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/fs.h>
#include <linux/init.h>

#include <linux/types.h>
#include <linux/cdev.h>
#include <linux/sched.h>
#include <linux/slab.h>
#include <asm/current.h>
#include <asm/uaccess.h>

MODULE_LICENSE("Dual BSD/GPL");

static int major_num = 0;
static int minor_num = 4;
// module_param(major_num, int, 0);
static struct cdev char_cdev;  

#define MY_BUF_SIZE 1024
static unsigned char k_buf[MY_BUF_SIZE];
static int pos;
static int read_count = 0;

static int char_open (struct inode *inode, struct file *file)
{
	printk ("----- This is the Open Function -----\n");
	printk ("Node NAME: %s:\n", NODE_NAME);
	printk ("MAJOR Number = %d, MINOR Number = %d\n",
			MAJOR (inode->i_rdev), MINOR (inode->i_rdev));

	printk ("Open device successfully: %s:\n", NODE_NAME);
	printk ("\n");

	return SUCCESS;
}

static int char_release (struct inode *inode, struct file *file)
{
	printk ("----- This is the Close Function -----\n");
	printk ("Closing device: %s:\n", NODE_NAME);
	printk ("\n");
	read_count = 0;

	return SUCCESS;
}

ssize_t char_read (struct file *filp, char __user *buf, size_t count, loff_t *f_pos)
{
	int len;

	printk ("----- This is the READ function -----\n");
	if (read_count) {
		return 0;
	}
	if ( count > pos )
		len = pos;
	else
		len = count;

	printk("k_buf is %s len = %d\n", k_buf, len);

	if (copy_to_user(buf, k_buf, len)) {
		printk( "copy_to_user failed\n");
		return -EFAULT;
	}
	printk ("\n");

	read_count++;

	return len;
}

ssize_t char_write (struct file *filp, const char __user *buf, size_t count, loff_t *f_pos)
{
	printk ("---- This is the WRITE function -----\n");

	if (copy_from_user(k_buf, buf, count)) {
		printk( "copy_from_user failed\n");
		return -EFAULT;
	}
	printk ("\n");
	pos = count;
	printk("k_buf is %s pos = %d\n", k_buf, pos);
	return count;
}

struct file_operations char_fops = {
	.read = char_read,
	.write = char_write,
	.open = char_open,
	.release = char_release
};

static int char_init_module(void)
{
	dev_t dev = MKDEV(major_num, 0);
	int major_num_ret;
	int cdev_ret = 0;
//	major_num_ret = register_chrdev (major_num, NODE_NAME, &char_fops);
	major_num_ret = alloc_chrdev_region(&dev, 0, minor_num, NODE_NAME);
	if (major_num_ret < 0) {
		printk ("Failed chrdev region %d\n", major_num_ret);
		unregister_chrdev_region(dev, minor_num);
		return major_num_ret;
	}
//	if (major_num_ret) {
	major_num = major_num_ret = MAJOR(dev);
//	}
	cdev_init(&char_cdev, &char_fops);
	char_cdev.owner = THIS_MODULE;

	cdev_ret = cdev_add(&char_cdev, MKDEV(major_num, 0), minor_num);
	if (cdev_ret < 0) {
		printk ("Failed cdev add %d\n", cdev_ret);
		cdev_del(&char_cdev);
		return cdev_ret;
	}
	printk ("Device registered successfully, Major No. = %d\n", major_num);
	return 0;
}

static void char_exit_module (void)
{
//	unregister_chrdev (major_num, NODE_NAME);
	dev_t dev = MKDEV(major_num, 0);

	cdev_del(&char_cdev);
	unregister_chrdev_region(dev, minor_num);

	printk ("Device unregistered successfully, Major No. = %d\n", major_num);
}

module_init(char_init_module);
module_exit(char_exit_module);
