// LN^foCX(LED)̃foCXhCo(cdev)
// W[ԍ͈Ŏw肵AΓIɊt

#define SUCCESS 0
#define NODE_NAME "char_drv"
#define MY_BUFF_SIZE 4096

#include <linux/miscdevice.h>
#include <linux/delay.h>
#include <asm/irq.h>
#include <asm/uaccess.h>
#include <asm/io.h>
#include <mach/regs-gpio.h>
#include <mach/hardware.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/mm.h>
#include <linux/fs.h>
#include <linux/types.h>
#include <linux/delay.h>
#include <linux/moduleparam.h>
#include <linux/slab.h>
#include <linux/errno.h>
#include <linux/ioctl.h>
#include <linux/cdev.h>
#include <linux/string.h>
#include <linux/list.h>
#include <linux/pci.h>
#include <linux/gpio.h>
#include <asm/uaccess.h>
#include <asm/atomic.h>

MODULE_LICENSE("Dual BSD/GPL");

static int major_num = 0;
static int minor_num = 4;
// module_param(major_num, int, 0);
static struct cdev char_cdev;  

#define MY_BUF_SIZE 1024
static unsigned char k_buf[MY_BUF_SIZE];
static int pos;
// static int read_count = 0;

static unsigned long gpio_led_table [] = {
	S3C2410_GPB(5),
	S3C2410_GPB(6),
	S3C2410_GPB(7),
	S3C2410_GPB(8)
};

static unsigned int gpio_led_cfg_table [] = {
	S3C2410_GPIO_OUTPUT,
	S3C2410_GPIO_OUTPUT,
	S3C2410_GPIO_OUTPUT,
	S3C2410_GPIO_OUTPUT
};

typedef struct my_buff {
	int bit;
} LED_BUFF;

static int char_open (struct inode *inode, struct file *filp)
{
	int minor = MINOR(inode->i_rdev);
	int bit = minor & 0x03;
	LED_BUFF *LedBuff;

	LedBuff = (LED_BUFF *)kmalloc (sizeof(LED_BUFF), GFP_KERNEL);
	LedBuff->bit = bit;
	filp->private_data = LedBuff;

	printk ("----- This is the Open Function -----\n");
	printk ("Node NAME: %s:\n", NODE_NAME);
	printk ("MAJOR Number = %d, MINOR Number = %d\n",
			MAJOR (inode->i_rdev), minor);

	printk ("Open device successfully: %s:\n\n", NODE_NAME);
	printk ("\n");

	return SUCCESS;
}

static int char_release (struct inode *inode, struct file *filp)
{
	LED_BUFF *LedBuff = (LED_BUFF *)filp -> private_data;
	kfree(LedBuff);
	printk ("----- This is the Close Function -----\n");
	printk ("Closing device: %s:\n\n", NODE_NAME);
	printk ("\n");

	return SUCCESS;
}

ssize_t char_read (struct file *filp, char __user *buf, size_t count, loff_t *f_pos)
{
        printk ("----- This is the READ function -----\n");
        printk ("\n");

        return count;
}

ssize_t char_write (struct file *filp, const char __user *buf, size_t count, loff_t *f_pos)
{
	volatile unsigned int  mode_port;
	volatile unsigned long data_port;

	LED_BUFF *LedBuff = (LED_BUFF *)filp -> private_data;
	int bit;

	printk ("---- This is the WRITE function -----\n");
        if (copy_from_user(k_buf, buf, count)) {
                printk( "copy_from_user failed\n");
                return -EFAULT;
        }
        printk ("\n");

	bit = LedBuff -> bit;
	mode_port = gpio_led_cfg_table[bit];
	data_port = gpio_led_table[bit];

	s3c2410_gpio_cfgpin(data_port, mode_port);
	s3c2410_gpio_setpin(data_port, !(*k_buf - '0'));

        pos = count;
        printk("k_buf is %s pos = %d\n", k_buf, pos);
        return count;
}

struct file_operations char_fops = {
	.read = char_read,
	.write = char_write,
	.open = char_open,
	.release = char_release
};

static int char_init_module(void)
{
	dev_t dev = MKDEV(major_num, 0);
	int major_num_ret;
	int cdev_ret = 0;
//	major_num_ret = register_chrdev (major_num, NODE_NAME, &char_fops);
	major_num_ret = alloc_chrdev_region(&dev, 0, minor_num, NODE_NAME);
	if (major_num_ret < 0) {
		printk ("Failed chrdev region %d\n", major_num_ret);
		unregister_chrdev_region(dev, minor_num);
		return major_num_ret;
	}
//	if (major_num_ret) {
	major_num = major_num_ret = MAJOR(dev);
//	}
	cdev_init(&char_cdev, &char_fops);
	char_cdev.owner = THIS_MODULE;

	cdev_ret = cdev_add(&char_cdev, MKDEV(major_num, 0), minor_num);
	if (cdev_ret < 0) {
		printk ("Failed cdev add %d\n", cdev_ret);
		cdev_del(&char_cdev);
		return cdev_ret;
	}
	printk ("Device registered successfully, Major No. = %d\n", major_num);
	return 0;
}

static void char_exit_module (void)
{
//	unregister_chrdev (major_num, NODE_NAME);
	dev_t dev = MKDEV(major_num, 0);

	cdev_del(&char_cdev);
	unregister_chrdev_region(dev, minor_num);

	printk ("Device unregistered successfully, Major No. = %d\n", major_num);
}

module_init(char_init_module);
module_exit(char_exit_module);
